struct VertexToPixel
{
    float4 Position     : POSITION;
    float Depth : TexCoord0;
};

struct PixelToFrame
{
    float4 Color : COLOR0;
};

float4x4 xWorldViewProj : WorldViewProjection;
float4x4 xWorldView : WorldView;

float4 xDoFParams : DOFParams; //x nearblur, y focalplane, z farblur, w cutoff

VertexToPixel ScreenQuadVertexShader( float4 inPos : POSITION)
{
    VertexToPixel Output = (VertexToPixel)0;


	Output.Position = mul(inPos,xWorldViewProj);
	Output.Depth = mul(inPos,xWorldView).z;

    return Output;
}

PixelToFrame DepthPixelShader(VertexToPixel PSIn)
{
    PixelToFrame Output;
	float f;
	
	/*if (PSIn.Depth < xDoFParams.y)
	{
		f = (PSIn.Depth - xDoFParams.y)/(xDoFParams.y - xDoFParams.x);
	}
	else
	{
		f = (PSIn.Depth - xDoFParams.y)/(xDoFParams.z - xDoFParams.y);
		f = clamp(f, 0, xDoFParams.w);
	}*/
	
	if (PSIn.Depth < xDoFParams.x)
	{
		f = (PSIn.Depth - xDoFParams.x)/(xDoFParams.y);
	}
	else
	{
		f = (PSIn.Depth - xDoFParams.x)/(xDoFParams.y);
		f = clamp(f, 0, xDoFParams.w);
	}
	
	Output.Color.r = f * 0.5 + 0.5;
	Output.Color.gb = PSIn.Depth;
	Output.Color.a = 1.0;
        
	return Output;
}

technique DepthDisp
{
    pass DepthDispPass
    {        
        VertexShader = compile vs_3_0 ScreenQuadVertexShader();
        PixelShader = compile ps_3_0 DepthPixelShader();
    }

}