struct VertexToPixel
{
    float4 Position     : POSITION;
    float2 TexCoords        : TEXCOORD0;
};

struct PixelToFrame
{
    float4 Color : COLOR0;
};

Texture xDiffuseTexture : DiffuseMap
<
	string ResourceName = "../textures/concrete_diffuse.jpg";
>;
float4x4 xWorldViewProj : WorldViewProjection;

sampler TextureSampler = sampler_state { texture = <xDiffuseTexture> ; magfilter = LINEAR; minfilter = LINEAR; mipfilter=LINEAR; AddressU = mirror; AddressV = mirror;};

VertexToPixel TextureVertexShader( float4 inPos : POSITION, float4 inTexCoord : TEXCOORD0)
{
    VertexToPixel Output = (VertexToPixel)0;

	Output.TexCoords = inTexCoord;

	Output.Position = mul(inPos,xWorldViewProj);

    return Output;    
}

PixelToFrame TexturePixelShader(VertexToPixel PSIn)
{
    PixelToFrame Output;
    Output.Color.rgb = tex2D(TextureSampler, PSIn.TexCoords).rgb;
  	Output.Color.a = 1.0;
    return Output;
}

technique Textured
{
    pass Pass0
    {        
        VertexShader = compile vs_1_1 TextureVertexShader();
        PixelShader = compile ps_1_1 TexturePixelShader();
    }
}